//+------------------------------------------------------------------+
//|                            Powerful 1 Min Scalping System EA.mq4 |
//|                              Copyright  2008, TradingSytemForex |
//|                                http://www.tradingsystemforex.com |
//+------------------------------------------------------------------+

#property copyright "Copyright  2008, TradingSytemForex"
#property link "http://www.tradingsystemforex.com"

#define OrSt "Powerful 1 Min Scalping System EA"

extern string TF="---------------- Time Filter";
extern int StartHour=20;
extern int EndHour=4;
extern string M1H="---------------- M1 Heiken Ashi";
extern int MaMetod=2;
extern int MaPeriod=6;
extern int MaMetod2=3;
extern int MaPeriod2=2;
extern string M5H="---------------- M5 Heiken Ashi";
extern int MaMetodb=2;
extern int MaPeriodb=30;
extern int MaMetod2b=3;
extern int MaPeriod2b=2;
extern string RSI="---------------- RSI";
extern double RSI_P=8;
extern double First_Level=55;
extern double Second_Level=45;
extern string CCI="---------------- DoublecciWoody";
extern int TrendCCI_Period=170;
extern int EntryCCI_Period=34;
extern string LM="---------------- Lot Management";
extern double Lots=0.1;
extern bool MM=false; //money management
extern double Risk=10; //risk in percentage
extern string TSTB="---------------- TP SL TS BE";
extern bool RealSL_Enabled=true;
extern int RealSL=10; //stop loss under 15 pps
bool RealTP_Enabled=false;
int RealTP=10; //take profit under 10 pps
extern int SL=0; //stop loss
extern int TP=0; //take profit
extern int TS=0; //trailing stop
extern int TS_Step=1; //trailing stop step
extern int BE=0; //breakeven
extern string EXT="---------------- Extras";
extern bool Reverse=false;
extern bool Add_Positions=false; //positions cumulated
extern int MaxOrders=100; //maximum number of orders
extern int Magic=0;

double HA1,HA2,HA3,HA4,RSI1,DW1,DW2,DW3,DW4;
double HiPrice, LoPrice, Range;
datetime StartTime;
bool dummyResult;

int Slip=3;static int TL=0;double MML=0;
double fib618,fib764,fib500,fib382,fib236,fib000,fib1000,fibm123,fibm1382,fibm1500,fibm1618,fibm1764,fibm2000,fibm2236,fibm2382,fibm2500,fibm2618,fibm2764,fibm3000,fibm3500,
fibm4000,fibm4500,fibm5000,fibm5500,fibm6000,fibp1236,fibp1382,fibp1500,fibp1618,fibp1764,fibp2000,fibp2236,fibp2500,fibp2618,fibp3000,fibp3500,fibp4000,fibp4500,fibp5000;

// expert start function
int start(){int j=0,limit=1;double BV=0,SV=0;BV=0;SV=0;
if(CntO(OP_BUY,Magic)>0)TL=1;if(CntO(OP_SELL,Magic)>0)TL=-1;
if (Hour()>=StartHour&&Hour()<EndHour) {for(int i=1;i<=limit;i++){
  
int shift	= iBarShift(NULL,PERIOD_D1,Time[0]) + 1;	// yesterday
HiPrice		= iHigh(NULL,PERIOD_D1,shift);
LoPrice		= iLow (NULL,PERIOD_D1,shift);
StartTime	= iTime(NULL,PERIOD_D1,shift);

if(TimeDayOfWeek(StartTime)==0/*Sunday*/)
{//Add fridays high and low
HiPrice = MathMax(HiPrice,iHigh(NULL,PERIOD_D1,shift+1));
LoPrice = MathMin(LoPrice,iLow(NULL,PERIOD_D1,shift+1));
}

Range = HiPrice-LoPrice;

fibp1236=HiPrice+(Range*0.236);
fibp1382=HiPrice+(Range*0.382);
fibp1500=HiPrice+(Range*0.5);
fibp1618=HiPrice+(Range*0.618);
fibp1764=HiPrice+(Range*0.764);
fibp2000=HiPrice+(Range*1);
fibp2236=HiPrice+(Range*1.236);
fibp2500=HiPrice+(Range*1.5);
fibp2618=HiPrice+(Range*1.618);
fibp3000=HiPrice+(Range*2);
fibp3500=HiPrice+(Range*2.5);
fibp4000=HiPrice+(Range*3);
fibp4500=HiPrice+(Range*3.5);
fibp5000=HiPrice+(Range*4);

fibm123=HiPrice-(Range*1.236);
fibm1382=HiPrice-(Range*1.382);
fibm1500=HiPrice-(Range*1.5);
fibm1618=HiPrice-(Range*1.618);
fibm1764=HiPrice-(Range*1.764);
fibm2000=HiPrice-(Range*2);
fibm2236=HiPrice-(Range*2.236);
fibm2382=HiPrice-(Range*2.382);
fibm2500=HiPrice-(Range*2.5);
fibm2618=HiPrice-(Range*2.618);
fibm2764=HiPrice-(Range*2.764);
fibm3000=HiPrice-(Range*3);
fibm3500=HiPrice-(Range*3.5);
fibm4000=HiPrice-(Range*4);
fibm4500=HiPrice-(Range*4.5);
fibm5000=HiPrice-(Range*5);
fibm5500=HiPrice-(Range*5.5);
fibm6000=HiPrice-(Range*6);

fib000=HiPrice-(Range*1);
fib236=HiPrice-(Range*0.764);
fib382=HiPrice-(Range*0.618);
fib500=HiPrice-(Range*0.5);
fib618=HiPrice-(Range*0.382);
fib764=HiPrice-(Range*0.236);
fib1000=HiPrice;

HA1=iCustom(Symbol(),0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,2,i);
HA2=iCustom(Symbol(),0,"Heiken_Ashi_Smoothed",MaMetod,MaPeriod,MaMetod2,MaPeriod2,3,i);
HA3=iCustom(Symbol(),0,"Heiken_Ashi_Smoothed",MaMetodb,MaPeriodb,MaMetod2b,MaPeriod2b,2,i);
HA4=iCustom(Symbol(),0,"Heiken_Ashi_Smoothed",MaMetodb,MaPeriodb,MaMetod2b,MaPeriod2b,3,i);

RSI1=iRSI(NULL,0,RSI_P,PRICE_CLOSE,i);

DW1=iCustom(Symbol(),0,"DoublecciWoody",TrendCCI_Period,EntryCCI_Period,4,i+1);
DW2=iCustom(Symbol(),0,"DoublecciWoody",TrendCCI_Period,EntryCCI_Period,4,i);
DW3=iCustom(Symbol(),0,"DoublecciWoody",TrendCCI_Period,EntryCCI_Period,5,i+1);
DW4=iCustom(Symbol(),0,"DoublecciWoody",TrendCCI_Period,EntryCCI_Period,5,i);
	
if(((Open[i+1]<fib000&&Open[i]>fib000)||(Open[i+1]<fib236&&Open[i]>fib236)||(Open[i+1]<fib382&&Open[i]>fib382)||(Open[i+1]<fib500&&Open[i]>fib500)||(Open[i+1]<fib618&&Open[i]>fib618)||
(Open[i+1]<fib764&&Open[i]>fib764)||(Open[i+1]<fib1000&&Open[i]>fib1000)||(Open[i+1]<fibp1236&&Open[i]>fibp1236)||(Open[i+1]<fibp1382&&Open[i]>fibp1382)||(Open[i+1]<fibp1500&&Open[i]>fibp1500)||
(Open[i+1]<fibp1618&&Open[i]>fibp1618)||(Open[i+1]<fibp1764&&Open[i]>fibp1764)||(Open[i+1]<fibp2000&&Open[i]>fibp2000)||(Open[i+1]<fibp2236&&Open[i]>fibp2236)||(Open[i+1]<fibp2500&&Open[i]>fibp2500)||
(Open[i+1]<fibp2618&&Open[i]>fibp2618)||(Open[i+1]<fibp3000&&Open[i]>fibp3000)||(Open[i+1]<fibp3500&&Open[i]>fibp3500)||(Open[i+1]<fibp4000&&Open[i]>fibp4000)||(Open[i+1]<fibp4500&&Open[i]>fibp4500)||
(Open[i+1]<fibp5000&&Open[i]>fibp5000)||(Open[i+1]<fibm123&&Open[i]>fibm123)||(Open[i+1]<fibm1382&&Open[i]>fibm1382)||(Open[i+1]<fibm1500&&Open[i]>fibm1500)||(Open[i+1]<fibm1618&&Open[i]>fibm1618)||
(Open[i+1]<fibm1764&&Open[i]>fibm1764)||(Open[i+1]<fibm2000&&Open[i]>fibm2000)||(Open[i+1]<fibm2236&&Open[i]>fibm2236)||(Open[i+1]<fibm2382&&Open[i]>fibm2382)||(Open[i+1]<fibm2500&&Open[i]>fibm2500)||
(Open[i+1]<fibm2618&&Open[i]>fibm2618)||(Open[i+1]<fibm2764&&Open[i]>fibm2764)||(Open[i+1]<fibm3000&&Open[i]>fibm3000)||(Open[i+1]<fibm3500&&Open[i]>fibm3500)||(Open[i+1]<fibm4000&&Open[i]>fibm4000)||
(Open[i+1]<fibm4500&&Open[i]>fibm4500)||(Open[i+1]<fibm5000&&Open[i]>fibm5000)||(Open[i+1]<fibm5500&&Open[i]>fibm5500)||(Open[i+1]<fibm6000&&Open[i]>fibm6000)||
(Open[i+2]<fib000&&Open[i+1]>fib000&&Open[i]>fib000)||(Open[i+2]<fib236&&Open[i+1]>fib236&&Open[i]>fib236)||(Open[i+2]<fib382&&Open[i+1]>fib382&&Open[i]>fib382)||
(Open[i+2]<fib500&&Open[i+1]>fib500&&Open[i]>fib500)||(Open[i+2]<fib618&&Open[i+1]>fib618&&Open[i]>fib618)||(Open[i+2]<fib764&&Open[i+1]>fib764&&Open[i]>fib764)||
(Open[i+2]<fib1000&&Open[i+1]>fib1000&&Open[i]>fib1000)||(Open[i+2]<fibp1236&&Open[i+1]>fibp1236&&Open[i]>fibp1236)||(Open[i+2]<fibp1382&&Open[i+1]>fibp1382&&Open[i]>fibp1382)||
(Open[i+2]<fibp1500&&Open[i+1]>fibp1500&&Open[i]>fibp1500)||(Open[i+2]<fibp1618&&Open[i+1]>fibp1618&&Open[i]>fibp1618)||(Open[i+2]<fibp1764&&Open[i+1]>fibp1764&&Open[i]>fibp1764)||
(Open[i+2]<fibp2000&&Open[i+1]>fibp2000&&Open[i]>fibp2000)||(Open[i+2]<fibp2236&&Open[i+1]>fibp2236&&Open[i]>fibp2236)||(Open[i+2]<fibp2500&&Open[i+1]>fibp2500&&Open[i]>fibp2500)||
(Open[i+2]<fibp2618&&Open[i+1]>fibp2618&&Open[i]>fibp2618)||(Open[i+2]<fibp3000&&Open[i+1]>fibp3000&&Open[i]>fibp3000)||(Open[i+2]<fibp3500&&Open[i+1]>fibp3500&&Open[i]>fibp3500)||
(Open[i+2]<fibp4000&&Open[i+1]>fibp4000&&Open[i]>fibp4000)||(Open[i+2]<fibp4500&&Open[i+1]>fibp4500&&Open[i]>fibp4500)||(Open[i+2]<fibp5000&&Open[i+1]>fibp5000&&Open[i]>fibp5000)||
(Open[i+2]<fibm123&&Open[i+1]>fibm123&&Open[i]>fibm123)||(Open[i+2]<fibm1382&&Open[i+1]>fibm1382&&Open[i]>fibm1382)||(Open[i+2]<fibm1500&&Open[i+1]>fibm1500&&Open[i]>fibm1500)||
(Open[i+2]<fibm1618&&Open[i+1]>fibm1618&&Open[i]>fibm1618)||(Open[i+2]<fibm1764&&Open[i+1]>fibm1764&&Open[i]>fibm1764)||(Open[i+2]<fibm2000&&Open[i+1]>fibm2000&&Open[i]>fibm2000)||
(Open[i+2]<fibm2236&&Open[i+1]>fibm2236&&Open[i]>fibm2236)||(Open[i+2]<fibm2382&&Open[i+1]>fibm2382&&Open[i]>fibm2382)||(Open[i+2]<fibm2500&&Open[i+1]>fibm2500&&Open[i]>fibm2500)||
(Open[i+2]<fibm2618&&Open[i+1]>fibm2618&&Open[i]>fibm2618)||(Open[i+2]<fibm2764&&Open[i+1]>fibm2764&&Open[i]>fibm2764)||(Open[i+2]<fibm3000&&Open[i+1]>fibm3000&&Open[i]>fibm3000)||
(Open[i+2]<fibm3500&&Open[i+1]>fibm3500&&Open[i]>fibm3500)||(Open[i+2]<fibm4000&&Open[i+1]>fibm4000&&Open[i]>fibm4000)||(Open[i+2]<fibm4500&&Open[i+1]>fibm4500&&Open[i]>fibm4500)||
(Open[i+2]<fibm5000&&Open[i+1]>fibm5000&&Open[i]>fibm5000)||(Open[i+2]<fibm5500&&Open[i+1]>fibm5500&&Open[i]>fibm5500)||(Open[i+2]<fibm6000&&Open[i+1]>fibm6000&&Open[i]>fibm6000)
)&&HA2>HA1&&HA4>HA3&&RSI1>First_Level&&DW3>0&&DW4>0&&DW2>0){if(Reverse)SV=1;else BV=1;break;}

if(((Open[i+1]>fib000&&Open[i]<fib000)||(Open[i+1]>fib236&&Open[i]<fib236)||(Open[i+1]>fib382&&Open[i]<fib382)||(Open[i+1]>fib500&&Open[i]<fib500)||(Open[i+1]>fib618&&Open[i]<fib618)||
(Open[i+1]>fib764&&Open[i]<fib764)||(Open[i+1]>fib1000&&Open[i]<fib1000)||(Open[i+1]>fibp1236&&Open[i]<fibp1236)||(Open[i+1]>fibp1382&&Open[i]<fibp1382)||(Open[i+1]>fibp1500&&Open[i]<fibp1500)||
(Open[i+1]>fibp1618&&Open[i]<fibp1618)||(Open[i+1]>fibp1764&&Open[i]<fibp1764)||(Open[i+1]>fibp2000&&Open[i]<fibp2000)||(Open[i+1]>fibp2236&&Open[i]<fibp2236)||(Open[i+1]>fibp2500&&Open[i]<fibp2500)||
(Open[i+1]>fibp2618&&Open[i]<fibp2618)||(Open[i+1]>fibp3000&&Open[i]<fibp3000)||(Open[i+1]>fibp3500&&Open[i]<fibp3500)||(Open[i+1]>fibp4000&&Open[i]<fibp4000)||(Open[i+1]>fibp4500&&Open[i]<fibp4500)||
(Open[i+1]>fibp5000&&Open[i]<fibp5000)||(Open[i+1]>fibm123&&Open[i]<fibm123)||(Open[i+1]>fibm1382&&Open[i]<fibm1382)||(Open[i+1]>fibm1500&&Open[i]<fibm1500)||(Open[i+1]>fibm1618&&Open[i]<fibm1618)||
(Open[i+1]>fibm1764&&Open[i]<fibm1764)||(Open[i+1]>fibm2000&&Open[i]<fibm2000)||(Open[i+1]>fibm2236&&Open[i]<fibm2236)||(Open[i+1]>fibm2382&&Open[i]<fibm2382)||(Open[i+1]>fibm2500&&Open[i]<fibm2500)||
(Open[i+1]>fibm2618&&Open[i]<fibm2618)||(Open[i+1]>fibm2764&&Open[i]<fibm2764)||(Open[i+1]>fibm3000&&Open[i]<fibm3000)||(Open[i+1]>fibm3500&&Open[i]<fibm3500)||(Open[i+1]>fibm4000&&Open[i]<fibm4000)||
(Open[i+1]>fibm4500&&Open[i]<fibm4500)||(Open[i+1]>fibm5000&&Open[i]<fibm5000)||(Open[i+1]>fibm5500&&Open[i]<fibm5500)||(Open[i+1]>fibm6000&&Open[i]<fibm6000)||
(Open[i+2]>fib000&&Open[i+1]<fib000&&Open[i]<fib000)||(Open[i+2]>fib236&&Open[i+1]<fib236&&Open[i]<fib236)||(Open[i+2]>fib382&&Open[i+1]<fib382&&Open[i]<fib382)||
(Open[i+2]>fib500&&Open[i+1]<fib500&&Open[i]<fib500)||(Open[i+2]>fib618&&Open[i+1]<fib618&&Open[i]<fib618)||(Open[i+2]>fib764&&Open[i+1]<fib764&&Open[i]<fib764)||
(Open[i+2]>fib1000&&Open[i+1]<fib1000&&Open[i]<fib1000)||(Open[i+2]>fibp1236&&Open[i+1]<fibp1236&&Open[i]<fibp1236)||(Open[i+2]>fibp1382&&Open[i+1]<fibp1382&&Open[i]<fibp1382)||
(Open[i+2]>fibp1500&&Open[i+1]<fibp1500&&Open[i]<fibp1500)||(Open[i+2]>fibp1618&&Open[i+1]<fibp1618&&Open[i]<fibp1618)||(Open[i+2]>fibp1764&&Open[i+1]<fibp1764&&Open[i]<fibp1764)||
(Open[i+2]>fibp2000&&Open[i+1]<fibp2000&&Open[i]<fibp2000)||(Open[i+2]>fibp2236&&Open[i+1]<fibp2236&&Open[i]<fibp2236)||(Open[i+2]>fibp2500&&Open[i+1]<fibp2500&&Open[i]<fibp2500)||
(Open[i+2]>fibp2618&&Open[i+1]<fibp2618&&Open[i]<fibp2618)||(Open[i+2]>fibp3000&&Open[i+1]<fibp3000&&Open[i]<fibp3000)||(Open[i+2]>fibp3500&&Open[i+1]<fibp3500&&Open[i]<fibp3500)||
(Open[i+2]>fibp4000&&Open[i+1]<fibp4000&&Open[i]<fibp4000)||(Open[i+2]>fibp4500&&Open[i+1]<fibp4500&&Open[i]<fibp4500)||(Open[i+2]>fibp5000&&Open[i+1]<fibp5000&&Open[i]<fibp5000)||
(Open[i+2]>fibm123&&Open[i+1]<fibm123&&Open[i]<fibm123)||(Open[i+2]>fibm1382&&Open[i+1]<fibm1382&&Open[i]<fibm1382)||(Open[i+2]>fibm1500&&Open[i+1]<fibm1500&&Open[i]<fibm1500)||
(Open[i+2]>fibm1618&&Open[i+1]<fibm1618&&Open[i]<fibm1618)||(Open[i+2]>fibm1764&&Open[i+1]<fibm1764&&Open[i]<fibm1764)||(Open[i+2]>fibm2000&&Open[i+1]<fibm2000&&Open[i]<fibm2000)||
(Open[i+2]>fibm2236&&Open[i+1]<fibm2236&&Open[i]<fibm2236)||(Open[i+2]>fibm2382&&Open[i+1]<fibm2382&&Open[i]<fibm2382)||(Open[i+2]>fibm2500&&Open[i+1]<fibm2500&&Open[i]<fibm2500)||
(Open[i+2]>fibm2618&&Open[i+1]<fibm2618&&Open[i]<fibm2618)||(Open[i+2]>fibm2764&&Open[i+1]<fibm2764&&Open[i]<fibm2764)||(Open[i+2]>fibm3000&&Open[i+1]<fibm3000&&Open[i]<fibm3000)||
(Open[i+2]>fibm3500&&Open[i+1]<fibm3500&&Open[i]<fibm3500)||(Open[i+2]>fibm4000&&Open[i+1]<fibm4000&&Open[i]<fibm4000)||(Open[i+2]>fibm4500&&Open[i+1]<fibm4500&&Open[i]<fibm4500)||
(Open[i+2]>fibm5000&&Open[i+1]<fibm5000&&Open[i]<fibm5000)||(Open[i+2]>fibm5500&&Open[i+1]<fibm5500&&Open[i]<fibm5500)||(Open[i+2]>fibm6000&&Open[i+1]<fibm6000&&Open[i]<fibm6000)
)&&HA1>HA2&&HA3>HA4&&RSI1<Second_Level&&DW3<0&&DW4<0&&DW2<0){if(Reverse)BV=1;else SV=1;break;}}}

// expert money management
if(MM){if(Risk<0.1||Risk>100){Comment("Invalid Risk Value.");return(0);}
else{MML=MathFloor((AccountFreeMargin()*AccountLeverage()*Risk*Point*100)/(Ask*MarketInfo(Symbol(),MODE_LOTSIZE)*MarketInfo(Symbol(),MODE_MINLOT)))*MarketInfo(Symbol(),MODE_MINLOT);}}
if(MM==false){MML=Lots;}

// expert init positions
int cnt=0,OP=0,OS=0,OB=0,CS=0,CB=0;OP=0;for(cnt=0;cnt<OrdersTotal();cnt++){dummyResult=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
if((OrderType()==OP_SELL||OrderType()==OP_BUY)&&OrderSymbol()==Symbol()&&((OrderMagicNumber()==Magic)||Magic==0))OP=OP+1;}
if(OP>=1){OS=0; OB=0;}OB=0;OS=0;CB=0;CS=0;

// expert conditions to open position
if(SV>0){OS=1;OB=0;}if(BV>0){OB=1;OS=0;}

// expert conditions to close position
if((Hour()==EndHour)){SV=0;BV=0;CB=1;CS=1;}
if((SV>0)||(HA1>HA2)||(RealSL_Enabled&&(OrderOpenPrice()-Bid)/Point>=RealSL)||(RealTP_Enabled&&(Ask-OrderOpenPrice())/Point>=RealTP)){CB=1;}
if((BV>0)||(HA2>HA1)||(RealSL_Enabled&&(Ask-OrderOpenPrice())/Point>=RealSL)||(RealTP_Enabled&&(OrderOpenPrice()-Bid)/Point>=RealTP)){CS=1;}
for(cnt=0;cnt<OrdersTotal();cnt++){dummyResult=OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
if(OrderType()==OP_BUY&&OrderSymbol()==Symbol()&&((OrderMagicNumber()==Magic)||Magic==0)){if(CB==1){dummyResult=OrderClose(OrderTicket(),OrderLots(),Bid,Slip,Red);return(0);}}
if(OrderType()==OP_SELL&&OrderSymbol()==Symbol()&&((OrderMagicNumber()==Magic)||Magic==0)){
if(CS==1){dummyResult=OrderClose(OrderTicket(),OrderLots(),Ask,Slip,Red);return(0);}}}double SLI=0,TPI=0;int TK=0;

// expert open position value
if((AddP()&&Add_Positions&&OP<=MaxOrders)||(OP==0&&!Add_Positions)){
if(OS==1){if(TP==0)TPI=0;else TPI=Bid-TP*Point;if(SL==0)SLI=0;else SLI=Bid+SL*Point;TK=OrderSend(Symbol(),OP_SELL,MML,Bid,Slip,SLI,TPI,OrSt,Magic,0,Red);OS=0;return(0);}	
if(OB==1){if(TP==0)TPI=0;else TPI=Ask+TP*Point;if(SL==0)SLI=0;else SLI=Ask-SL*Point;TK=OrderSend(Symbol(),OP_BUY,MML,Ask,Slip,SLI,TPI,OrSt,Magic,0,Lime);OB=0; return(0);}}
for(j=0;j<OrdersTotal();j++){if(OrderSelect(j,SELECT_BY_POS,MODE_TRADES)){if(OrderSymbol()==Symbol()&&((OrderMagicNumber()==Magic)||Magic==0)){TrP();}}}return(0);}

// expert number of orders
int CntO(int Type,int tMagic){int _CntO;_CntO=0;
// needs double checking
for(int j=0;j<OrdersTotal();j++){dummyResult=OrderSelect(j,SELECT_BY_POS,MODE_TRADES);if(OrderSymbol()==Symbol()){if(OrderType()==Type&&(OrderMagicNumber()==tMagic||tMagic==0))_CntO++;}}return(_CntO);}

//expert breakeven
void TrP(){double pb,pa,pp;pp=MarketInfo(OrderSymbol(),MODE_POINT);if(OrderType()==OP_BUY){pb=MarketInfo(OrderSymbol(),MODE_BID);
if(BE>0){if((pb-OrderOpenPrice())>BE*pp){if((OrderStopLoss()-OrderOpenPrice())<0){ModSL(OrderOpenPrice()+0*pp);}}}

// expert trailing stop
if(TS>0){if((pb-OrderOpenPrice())>TS*pp){if(OrderStopLoss()<pb-(TS+TS_Step-1)*pp){ModSL(pb-TS*pp);return;}}}}
if(OrderType()==OP_SELL){pa=MarketInfo(OrderSymbol(),MODE_ASK);if(BE>0){if((OrderOpenPrice()-pa)>BE*pp){if((OrderOpenPrice()-OrderStopLoss())<0){ModSL(OrderOpenPrice()-0*pp);}}}
if(TS>0){if(OrderOpenPrice()-pa>TS*pp){if(OrderStopLoss()>pa+(TS+TS_Step-1)*pp||OrderStopLoss()==0){ModSL(pa+TS*pp);return;}}}}}

//expert stoploss
void ModSL(double ldSL){bool fm;fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldSL,OrderTakeProfit(),0,CLR_NONE);}

//expert add positions function
bool AddP(){int _num=0; int _ot=0;
for (int j=0;j<OrdersTotal();j++){if(OrderSelect(j,SELECT_BY_POS)==true && OrderSymbol()==Symbol()&&OrderType()<3&&((OrderMagicNumber()==Magic)||Magic==0)){	
_num++;if(OrderOpenTime()>_ot) _ot=OrderOpenTime();}}if(_num==0) return(true);if(_num>0 && ((Time[0]-_ot))>0) return(true);else return(false);}